//Nicholas Zakhar
//CIS 587
//Final Project
//12-21-05

// INCLUDES ///////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN  

// you must #define INITGUID if not done elsewhere
#define INITGUID

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>
#include <iostream> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>

#include <ddraw.h>     // directX includes
#include <dsound.h> // include dsound, dmusic
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>

#include "T3DLIB1.H"
#include "T3DLIB3.H"

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"

// setup a 800x600 16-bit non-windowed mode
#define WINDOW_TITLE      "Warbound"
#define WINDOW_WIDTH      800   // size of window
#define WINDOW_HEIGHT     600

#define WINDOW_BPP        16    // bitdepth of window (8,16,24 etc.)
                                // note: if windowed and not
                                // fullscreen then bitdepth must
                                // be same as system bitdepth
                                // also if 8-bit the a pallete
                                // is created and attached

#define WINDOWED_APP      1     // 0 not windowed, 1 windowed

#define BITMAP_ID            0x4D42 // universal id for a bitmap
#define MAX_COLORS_PALETTE   256

#define NUM_TEXTURES         8 // normally this would be a multiple of 16 or something!

// STRUCT /////////////////////////////////////////////////

struct game_unit  // this struct hold all the information about each unit in the game.
{
	char name[8];         // unit's name
	int cclass;           // unit's class 1 = fighter, 2 = ranger, 3 = horsemen
	int fighter_level;    // unit's fighter levels
	int ranger_level;     // unit's ranger levels
	int horsemen_level;   // unit's horsemen levels
	int current_HP;       // unit's current hitpoints
	int defense_bonus;    // unit's defense bonus from defense actions
	int HP;               // unit's total hitpoints
	int attack;           // unit's attack
	int defense;          // unit's defense
	int movement;         // unit's total movement
	int XP;               // unit's current experience
	int next_level;       // experience needed for next level
	bool turn_done;       // is the unit's turn done?
	bool move_done;		  // is the unit's move done?
};

// PROTOTYPES /////////////////////////////////////////////

// game console
int Game_Init(void *parms=NULL, int num_parms = 0);
int Game_Shutdown(void *parms=NULL, int num_parms = 0);
int Game_Main(void *parms=NULL,  int num_parms = 0);

// Functions //////////////////////////////////////////////
void Setup();           // set initial unit values
void Unit_Movement(int,int);   // sets squares for movement
void Recusive_Move(int,int,int);  // recursively sets squares for movment
int Attackfunction(game_unit,game_unit,float); // resolves the attack
void AI_Move(int&,int&);  // resolves the AI moves
void Add_XP(game_unit,game_unit,int);  // adds xp and levels to units as needed

// GLOBALS ////////////////////////////////////////////////

// windows vars
HWND      main_window_handle = NULL; // globally track main window
int       window_closed      = 0;    // tracks if window is closed
HINSTANCE main_instance      = NULL; // globally track hinstance

char buffer[80];                // used to print text

// BOB globals
BOB          textures;        // texture memory
BOB          curser;          // the curser
BOB          garret;          // 1st character
BOB			 garret_ranger;   // 1st character as ranger
BOB			 garret_horsemen; // 1st character as horsemen
BOB          sabra;           // 2st character
BOB			 sabra_ranger;    // 2st character as ranger
BOB			 sabra_horsemen;  // 2st character as horsemen
BOB          baldur;          // 3st character
BOB			 baldur_ranger;   // 3st character as ranger
BOB			 baldur_horsemen; // 3st character as horsemen
BOB          enemyboss;       // main enemy
BOB          enemyminion;     // other enemies
BOB			 victory;         // victory message
BOB          defeat;          // defeat message

BOB_PTR object_ptr; // pointer to bob

// sound globals
int music;
int battle_sound;
int victory_sound;
int defeat_sound;
int move_sound;
int defend_sound;


int world_x = 0,   // current position of viewing window
    world_y = 0;

int curser_x = 64, //current position of the game curser
    curser_y = 64;

int curserindex_x = 1,  //current position index of the curser
	curserindex_y = 1;

bool curserflag = true;   // this flag is set if the player is allowed to move the curser
bool canmoveflag = false;  //can the game move the unit?
bool attackflag = false;  //can the player attack?
bool victoryflag = false;  //has the player won?
bool defeatflag = false;  //has the player lost?

int orderposition = -1;   //this stores which menu item the player is currently on
int unit_move;  //the index of unit you want to move

int temp_cx; //stores c cord temeraraly
int temp_cy;  //stores y cord temperaraly
int unit_temp;  //stores unit info temperaraly

int turn;  // keeps track of the current game turn;

game_unit Garretinfo;  // 1st player unit
game_unit Sabrainfo;   // 2nd player unit
game_unit Baldurinfo;  // 3rd player unit
game_unit Boss;        // main boss unit
game_unit Minion1;     // 1st enemy unit
game_unit Minion2;     // 2nd enemy unit
game_unit Minion3;     // 3rd enemy unit
game_unit Minion4;     // 4th enemy unit
game_unit Minion5;     // 5th enemy unit

// use an array of string pointers, could have used an
// array of chars or int, but harder to initialize
// the characters '0' - '9' represent bitmaps 0-9 in some texture memory
char *world[21] = 
{
"111111111111111111111111111111",
"155445555533335555555555555521",
"154443552555333355255555555551",
"155443322222232333555553335521",
"155433322222277225555553355551",
"125444427222227555557777725551",
"125554444775275552277667755221",
"122544444447777557776667555221",
"125522224444422777676667755221",
"122345244444777766677777555521",
"124455224474766666667772225551",
"122222222777776666666677255551",
"122222444766666666667777755551",
"155554447777776666677755555521",
"153355557227777666772555552221",
"133334445222227777722225555221",
"133333444552233322222255522221",
"133333335523333222255222555221",
"133333333533332222255225557721",
"133333353332222255522555772251",
"111111111111111111111111111111",

};

// stores the locations of all the units in the game
int unit_x[10];
int unit_y[10];

// stores the moves that the unit can make
int move_x[630];
int move_y[630];
int move_index;

// PROTOTYPES //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT		ps;		// used in WM_PAINT
HDC				hdc;	// handle to a device context
char buffer[80];        // used to print strings

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
        // return success
		return(0);
		} break;
   
	case WM_PAINT: 
		{
		// simply validate the window 
   	    hdc = BeginPaint(hwnd,&ps);	 
        
        // end painting
        EndPaint(hwnd,&ps);

        // return success
		return(0);
   		} break;

	case WM_DESTROY: 
		{

		// kill the application, this sends a WM_QUIT message 
		PostQuitMessage(0);

        // return success
		return(0);
		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
HDC        hdc;      // graphics device context

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

// save hinstance in global
main_instance = hinstance;

// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    WINDOW_TITLE, // title
						    (WINDOWED_APP ? (WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION) : (WS_POPUP | WS_VISIBLE)), 
					 	    0,0,	  // initial x,y
						    WINDOW_WIDTH,WINDOW_HEIGHT,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

// save main window handle
main_window_handle = hwnd;

if (WINDOWED_APP)
{
// now resize the window, so the client area is the actual size requested
// since there may be borders and controls if this is going to be a windowed app
// if the app is not windowed then it won't matter
RECT window_rect = {0,0,WINDOW_WIDTH-1,WINDOW_HEIGHT-1};

// make the call to adjust window_rect
AdjustWindowRectEx(&window_rect,
     GetWindowStyle(main_window_handle),
     GetMenu(main_window_handle) != NULL,
     GetWindowExStyle(main_window_handle));

// save the global client offsets, they are needed in DDraw_Flip()
window_client_x0 = -window_rect.left;
window_client_y0 = -window_rect.top;

// now resize the window with a call to MoveWindow()
MoveWindow(main_window_handle,
           0, // x position
           0, // y position
           window_rect.right - window_rect.left, // width
           window_rect.bottom - window_rect.top, // height
           TRUE);

// show the window, so there's no garbage on first render
ShowWindow(main_window_handle, SW_SHOW);
} // end if windowed

// initialize game here
Game_Init();

// setup the inital unit variables
Setup();

// start the game music
DSound_Play(music,DSBPLAY_LOOPING);

// enter main event loop
while(TRUE)
	{
    // test if there is a message in queue, if so get it
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 
	   // test if this is a quit
       if (msg.message == WM_QUIT)
           break;
	
	   // translate any accelerator keys
	   TranslateMessage(&msg);

	   // send the message to the window proc
	   DispatchMessage(&msg);
	   } // end if
    
       // main game processing goes here
       Game_Main();
       
	} // end while

// closedown game here
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain

// GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms,  int num_parms)
{
// this function is where you do all the initialization 
// for your game

int index;         // looping var
char filename[80]; // used to build up files names

// initialize directsound
DSound_Init();

// initialize directmusic
DMusic_Init();

// load in the digital sound and music
battle_sound = DSound_Load_WAV("Combat_Skirmish.wav");
victory_sound = DSound_Load_WAV("Combat_BattleWon.wav");
defeat_sound = DSound_Load_WAV("Combat_BattleLost.wav");
move_sound = DSound_Load_WAV("Unit_ArmyMove.wav");
defend_sound = DSound_Load_WAV("Unit_ArmySelected.wav");

music = DSound_Load_WAV("CROSS_OR_CROWN.wav");

// start up DirectDraw (replace the parms as you desire)
DDraw_Init(WINDOW_WIDTH, WINDOW_HEIGHT, WINDOW_BPP, WINDOWED_APP);

//****************************************************************************************
//Textures BOB

// load in texture maps
Load_Bitmap_File(&bitmap16bit, "TERRAINTEXTURES.BMP");

// create the texture bob
if (!Create_BOB(&textures,0,0,64,64,8, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

// load each texture bitmap into the texture BOB object
for (index = 0; index < NUM_TEXTURES; index++)
    Load_Frame_BOB16(&textures,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

// unload the texture map bitmap
Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Curser BOB

Load_Bitmap_File(&bitmap16bit, "CURSER.BMP");

if (!Create_BOB(&curser,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&curser,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Garret BOB

Load_Bitmap_File(&bitmap16bit, "GARRET.BMP");

if (!Create_BOB(&garret,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&garret,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&garret, 0);
Set_Anim_Speed_BOB(&garret, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Garret Ranger BOB

Load_Bitmap_File(&bitmap16bit, "GARRETRANGER.BMP");

if (!Create_BOB(&garret_ranger,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&garret_ranger,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&garret_ranger, 0);
Set_Anim_Speed_BOB(&garret_ranger, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Garret Hoursemen BOB

Load_Bitmap_File(&bitmap16bit, "GARRETHORSEMEN.BMP");

if (!Create_BOB(&garret_horsemen,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&garret_horsemen,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&garret_horsemen, 0);
Set_Anim_Speed_BOB(&garret_horsemen, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Sabra BOB

Load_Bitmap_File(&bitmap16bit, "SABRA.BMP");

if (!Create_BOB(&sabra,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&sabra,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&sabra, 0);
Set_Anim_Speed_BOB(&sabra, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Sabra Ranger BOB

Load_Bitmap_File(&bitmap16bit, "SABRARANGER.BMP");

if (!Create_BOB(&sabra_ranger,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&sabra_ranger,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&sabra_ranger, 0);
Set_Anim_Speed_BOB(&sabra_ranger, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Sabra Hoursemen BOB

Load_Bitmap_File(&bitmap16bit, "SABRAHORSEMEN.BMP");

if (!Create_BOB(&sabra_horsemen,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&sabra_horsemen,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&sabra_horsemen, 0);
Set_Anim_Speed_BOB(&sabra_horsemen, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Baldur BOB

Load_Bitmap_File(&bitmap16bit, "BALDUR.BMP");

if (!Create_BOB(&baldur,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&baldur,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&baldur, 0);
Set_Anim_Speed_BOB(&baldur, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Baldur Ranger BOB

Load_Bitmap_File(&bitmap16bit, "BALDURRANGER.BMP");

if (!Create_BOB(&baldur_ranger,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&baldur_ranger,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&baldur_ranger, 0);
Set_Anim_Speed_BOB(&baldur_ranger, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Baldur Hoursemen BOB

Load_Bitmap_File(&bitmap16bit, "BALDURHORSEMEN.BMP");

if (!Create_BOB(&baldur_horsemen,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&baldur_horsemen,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&baldur_horsemen, 0);
Set_Anim_Speed_BOB(&baldur_horsemen, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Enemy Boss BOB

Load_Bitmap_File(&bitmap16bit, "ENEMYBOSS.BMP");

if (!Create_BOB(&enemyboss,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&enemyboss,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&enemyboss, 0);
Set_Anim_Speed_BOB(&enemyboss, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Enemy Minion BOB

Load_Bitmap_File(&bitmap16bit, "ENEMYMINION.BMP");

if (!Create_BOB(&enemyminion,0,0,64,64,2, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (index = 0; index < 2; index++)
    Load_Frame_BOB16(&enemyminion,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

Set_Animation_BOB(&enemyminion, 0);
Set_Anim_Speed_BOB(&enemyminion, 40);

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Victory BOB

Load_Bitmap_File(&bitmap16bit, "VICTORY.BMP");

if (!Create_BOB(&victory,0,0,500,154,1, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

Load_Frame_BOB16(&victory,&bitmap16bit,0,0,0,BITMAP_EXTRACT_MODE_CELL); 

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************

//****************************************************************************************
//Defeat BOB

Load_Bitmap_File(&bitmap16bit, "DEFEAT.BMP");

if (!Create_BOB(&defeat,0,0,500,154,1, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

Load_Frame_BOB16(&defeat,&bitmap16bit,0,0,0,BITMAP_EXTRACT_MODE_CELL); 

Unload_Bitmap_File(&bitmap16bit);

//****************************************************************************************
//****************************************************************************************

// hide the mouse
if (!WINDOWED_APP)
    ShowCursor(FALSE);

// return success
return(1);

} // end Game_Init

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms,  int num_parms)
{
// this function is where you shutdown your game and
// release all resources that you allocated

// kill BOB memory
Destroy_BOB(&textures);
Destroy_BOB(&curser);
Destroy_BOB(&garret);
Destroy_BOB(&garret_ranger);
Destroy_BOB(&garret_horsemen);
Destroy_BOB(&sabra);
Destroy_BOB(&sabra_ranger);
Destroy_BOB(&sabra_horsemen);
Destroy_BOB(&baldur);
Destroy_BOB(&baldur_ranger);
Destroy_BOB(&baldur_horsemen);
Destroy_BOB(&enemyboss);
Destroy_BOB(&enemyminion);
Destroy_BOB(&victory);
Destroy_BOB(&defeat);

// stop all sounds
DSound_Stop_All_Sounds();

// delete all sounds
DSound_Delete_All_Sounds();

// shutdown directsound
DSound_Shutdown();

// delete all the music
DMusic_Delete_All_MIDI();

// shutdown directmusic
DMusic_Shutdown();

// shutdown directdraw
DDraw_Shutdown();

// return success
return(1);
} // end Game_Shutdown

///////////////////////////////////////////////////////////

int Game_Main(void *parms, int num_parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!

int index, index_x, index_y;  // looping vars
int start_map_x,start_map_y,  // map positions
    end_map_x,end_map_y; 

int temp_x, temp_y; // temparary x/y variables

int offset_x, offset_y;       // pixel offsets within cell

bool moveflag = false;  //can the player move?
bool movethereflag = false;

int index2;  // looping index
float bonus;  // stores terrain bonus defense

int x; // stores x cord
int y; // stores y cord

int damagetemp;  // stores damage temperaraly

game_unit game_unit_temp;  // stores game_units

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);

// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);

if (victoryflag || defeatflag) // has the player won/lost?
{
	// the game is over (victory/defeat) so end the game the next time a key is hit
	if (KEY_DOWN(VK_ESCAPE) || KEY_DOWN(VK_RETURN) || KEY_DOWN(VK_UP) || KEY_DOWN(VK_DOWN) || KEY_DOWN(VK_LEFT) || KEY_DOWN(VK_RIGHT))
		PostMessage(main_window_handle, WM_DESTROY,0,0);
}

//THE COMPUTER'S TURN
if (((Garretinfo.turn_done) || (Garretinfo.current_HP <= 0)) && ((Sabrainfo.turn_done) || (Sabrainfo.current_HP <= 0)) && ((Baldurinfo.turn_done) || (Baldurinfo.current_HP <= 0)))
{
	// if the unit is NOT dead, and the game isn't over
	if((unit_x[4] != -1) && (!defeatflag))
	{
		Unit_Movement(unit_x[4],unit_y[4]); // find the valid moves
		move_x[move_index] = unit_x[4]; // add the square the unit is standing in to the move possible move list
		move_y[move_index] = unit_y[4];
		move_index++;

		AI_Move(x,y);  // have the computer select it's move

		if((x != unit_x[4]) || (y != unit_y[4]))  // if the unit has moved, destroy it's defense bonus
			Boss.defense_bonus = 0;

		unit_x[4] = x;  // move the unit's x
		unit_y[4] = y;  // move the unit's y

		move_index = 0;

		// is garret next to this unit? if yes then attack him, else look for someone else, else defend
		if (((unit_x[1] == (x + 1)) && (unit_y[1] == y)) || ((unit_x[1] == (x - 1)) && (unit_y[1] == y)) || ((unit_x[1] == x) && (unit_y[1] == (y + 1))) || ((unit_x[1] == x) && (unit_y[1] == (y -1))))
		{ 
			// find the terrain bonus for the terrain the unit's on
			if ((world[unit_y[1]][unit_x[1]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 7)
				bonus = 20;
			
			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Garretinfo,Boss,bonus);
			Garretinfo.current_HP = Garretinfo.current_HP - damagetemp;
		}
		// is sabra next to this unit?  if yes then attack her, else look for someone else, else defend
		else if (((unit_x[2] == (x + 1)) && (unit_y[2] == y)) || ((unit_x[2] == (x - 1)) && (unit_y[2] == y)) || ((unit_x[2] == x) && (unit_y[2] == (y + 1))) || ((unit_x[2] == x) && (unit_y[2] == (y -1))))
		{
			if ((world[unit_y[2]][unit_x[2]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Sabrainfo,Boss,bonus);
			Sabrainfo.current_HP = Sabrainfo.current_HP - damagetemp;
		}
		// is baldur next to this unit?  if yes then attack her, else look for someone else,
		else if (((unit_x[3] == (x + 1)) && (unit_y[3] == y)) || ((unit_x[3] == (x - 1)) && (unit_y[3] == y)) || ((unit_x[3] == x) && (unit_y[3] == (y + 1))) || ((unit_x[3] == x) && (unit_y[3] == (y -1))))
		{
			if ((world[unit_y[3]][unit_x[3]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Baldurinfo,Boss,bonus);
			Baldurinfo.current_HP = Baldurinfo.current_HP - damagetemp;
		}
		else // you can't attack, so defend
		{
			if(Boss.defense_bonus < 15) // add 5 to the unit's defense if it's < 15
				Boss.defense_bonus = Boss.defense_bonus + 5;
		}
	}
	// if the unit is NOT dead, and the game isn't over
	if((unit_x[5] != -1) && (!defeatflag))
	{
		Unit_Movement(unit_x[5],unit_y[5]); // find the valid moves
		move_x[move_index] = unit_x[5]; // add the square the unit is standing in to the move possible move list
		move_y[move_index] = unit_y[5];
		move_index++;

		AI_Move(x,y); // have the computer select it's move

		if((x != unit_x[5]) || (y != unit_y[5])) // if the unit has moved, destroy it's defense bonus
			Minion1.defense_bonus = 0;
		
		unit_x[5] = x; // move the unit's x
		unit_y[5] = y; // move the unit's y

		move_index = 0;

		// is garret next to this unit? if yes then attack him, else look for someone else, else defend
		if (((unit_x[1] == (x + 1)) && (unit_y[1] == y)) || ((unit_x[1] == (x - 1)) && (unit_y[1] == y)) || ((unit_x[1] == x) && (unit_y[1] == (y + 1))) || ((unit_x[1] == x) && (unit_y[1] == (y -1))))
		{ 
			// find the terrain bonus for the terrain the unit's on
			if ((world[unit_y[1]][unit_x[1]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Garretinfo,Minion1,bonus);
			Garretinfo.current_HP = Garretinfo.current_HP - damagetemp;
		}
		// is sabra next to this unit?  if yes then attack her, else look for someone else,
		else if (((unit_x[2] == (x + 1)) && (unit_y[2] == y)) || ((unit_x[2] == (x - 1)) && (unit_y[2] == y)) || ((unit_x[2] == x) && (unit_y[2] == (y + 1))) || ((unit_x[2] == x) && (unit_y[2] == (y -1))))
		{
			if ((world[unit_y[2]][unit_x[2]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Sabrainfo,Minion1,bonus);
			Sabrainfo.current_HP = Sabrainfo.current_HP - damagetemp;
		}
		// is baldur next to this unit?  if yes then attack him, else look for someone else,
		else if (((unit_x[3] == (x + 1)) && (unit_y[3] == y)) || ((unit_x[3] == (x - 1)) && (unit_y[3] == y)) || ((unit_x[3] == x) && (unit_y[3] == (y + 1))) || ((unit_x[3] == x) && (unit_y[3] == (y -1))))
		{
			if ((world[unit_y[3]][unit_x[2]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Baldurinfo,Minion1,bonus);
			Baldurinfo.current_HP = Baldurinfo.current_HP - damagetemp;
		}
		else // you can't attack, so defend
		{
			if(Minion1.defense_bonus < 15) // add 5 to the unit's defense if it's < 15
				Minion1.defense_bonus = Minion1.defense_bonus + 5;
		}
	}
	// if the unit is NOT dead, and the game isn't over
	if((unit_x[6] != -1) && (!defeatflag))
	{
		Unit_Movement(unit_x[6],unit_y[6]); // find the valid moves
		move_x[move_index] = unit_x[6]; // add the square the unit is standing in to the move possible move list
		move_y[move_index] = unit_y[6];
		move_index++;

		AI_Move(x,y);  // have the computer select it's move

		if((x != unit_x[6]) || (y != unit_y[6])) // if the unit has moved, destroy it's defense bonus
			Minion2.defense_bonus = 0;
		
		unit_x[6] = x; // move the unit's x
		unit_y[6] = y; // move the unit's y

		move_index = 0;

		// is garret next to this unit? if yes then attack him, else look for someone else, else defend
		if (((unit_x[1] == (x + 1)) && (unit_y[1] == y)) || ((unit_x[1] == (x - 1)) && (unit_y[1] == y)) || ((unit_x[1] == x) && (unit_y[1] == (y + 1))) || ((unit_x[1] == x) && (unit_y[1] == (y -1))))
		{ 
			// find the terrain bonus for the terrain the unit's on
			if ((world[unit_y[1]][unit_x[1]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Garretinfo,Minion2,bonus);
			Garretinfo.current_HP = Garretinfo.current_HP - damagetemp;
		}
		// is sabra next to this unit?  if yes then attack her, else look for someone else,
		else if (((unit_x[2] == (x + 1)) && (unit_y[2] == y)) || ((unit_x[2] == (x - 1)) && (unit_y[2] == y)) || ((unit_x[2] == x) && (unit_y[2] == (y + 1))) || ((unit_x[2] == x) && (unit_y[2] == (y -1))))
		{
			if ((world[unit_y[2]][unit_x[2]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Sabrainfo,Minion2,bonus);
			Sabrainfo.current_HP = Sabrainfo.current_HP - damagetemp;
		}
		// is baldur next to this unit?  if yes then attack him, else look for someone else,
		else if (((unit_x[3] == (x + 1)) && (unit_y[3] == y)) || ((unit_x[3] == (x - 1)) && (unit_y[3] == y)) || ((unit_x[3] == x) && (unit_y[3] == (y + 1))) || ((unit_x[3] == x) && (unit_y[3] == (y -1))))
		{
			if ((world[unit_y[3]][unit_x[3]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Baldurinfo,Minion2,bonus);
			Baldurinfo.current_HP = Baldurinfo.current_HP - damagetemp;
		}
		else // you can't attack, so defend
		{
			if(Minion2.defense_bonus < 15) // add 5 to the unit's defense if it's < 15
				Minion2.defense_bonus = Minion2.defense_bonus + 5;
		}
	}
	// if the unit is NOT dead, and the game isn't over
	if((unit_x[7] != -1) && (!defeatflag))
	{
		Unit_Movement(unit_x[7],unit_y[7]); // find the valid moves
		move_x[move_index] = unit_x[7]; // add the square the unit is standing in to the move possible move list
		move_y[move_index] = unit_y[7];
		move_index++;

		AI_Move(x,y); // have the computer select it's move

		if((x != unit_x[7]) || (y != unit_y[7])) // if the unit has moved, destroy it's defense bonus
			Minion3.defense_bonus = 0;
		
		unit_x[7] = x; // move the unit's x
		unit_y[7] = y; // move the unit's y

		move_index = 0;

		// is garret next to this unit? if yes then attack him, else look for someone else, else defend
		if (((unit_x[1] == (x + 1)) && (unit_y[1] == y)) || ((unit_x[1] == (x - 1)) && (unit_y[1] == y)) || ((unit_x[1] == x) && (unit_y[1] == (y + 1))) || ((unit_x[1] == x) && (unit_y[1] == (y -1))))
		{ 
			// find the terrain bonus for the terrain the unit's on
			if ((world[unit_y[1]][unit_x[1]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Garretinfo,Minion3,bonus);
			Garretinfo.current_HP = Garretinfo.current_HP - damagetemp;
		}
		// is sabra next to this unit?  if yes then attack her, else look for someone else,
		else if (((unit_x[2] == (x + 1)) && (unit_y[2] == y)) || ((unit_x[2] == (x - 1)) && (unit_y[2] == y)) || ((unit_x[2] == x) && (unit_y[2] == (y + 1))) || ((unit_x[2] == x) && (unit_y[2] == (y -1))))
		{
			if ((world[unit_y[2]][unit_x[2]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Sabrainfo,Minion3,bonus);
			Sabrainfo.current_HP = Sabrainfo.current_HP - damagetemp;
		}
		// is baldur next to this unit?  if yes then attack him, else look for someone else,
		else if (((unit_x[3] == (x + 1)) && (unit_y[3] == y)) || ((unit_x[3] == (x - 1)) && (unit_y[3] == y)) || ((unit_x[3] == x) && (unit_y[3] == (y + 1))) || ((unit_x[3] == x) && (unit_y[3] == (y -1))))
		{
			if ((world[unit_y[3]][unit_x[2]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Baldurinfo,Minion3,bonus);
			Baldurinfo.current_HP = Baldurinfo.current_HP - damagetemp;
		}
		else // you can't attack, so defend
		{
			if(Minion3.defense_bonus < 15) // add 5 to the unit's defense if it's < 15
				Minion3.defense_bonus = Minion3.defense_bonus + 5;
		}
	}
	// if the unit is NOT dead, and the game isn't over
	if((unit_x[8] != -1) && (!defeatflag))
	{
		Unit_Movement(unit_x[8],unit_y[8]); // find the valid moves
		move_x[move_index] = unit_x[8]; // add the square the unit is standing in to the move possible move list
		move_y[move_index] = unit_y[8];
		move_index++;

		AI_Move(x,y); // have the computer select it's move

		if((x != unit_x[8]) || (y != unit_y[8])) // if the unit has moved, destroy it's defense bonus
			Minion4.defense_bonus = 0;
		
		unit_x[8] = x; // move the unit's x
		unit_y[8] = y; // move the unit's y

		move_index = 0;

		// is garret next to this unit? if yes then attack him, else look for someone else, else defend
		if (((unit_x[1] == (x + 1)) && (unit_y[1] == y)) || ((unit_x[1] == (x - 1)) && (unit_y[1] == y)) || ((unit_x[1] == x) && (unit_y[1] == (y + 1))) || ((unit_x[1] == x) && (unit_y[1] == (y -1))))
		{ 
			// find the terrain bonus for the terrain the unit's on
			if ((world[unit_y[1]][unit_x[1]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Garretinfo,Minion4,bonus);
			Garretinfo.current_HP = Garretinfo.current_HP - damagetemp;
		}
		// is sabra next to this unit?  if yes then attack her, else look for someone else,
		else if (((unit_x[2] == (x + 1)) && (unit_y[2] == y)) || ((unit_x[2] == (x - 1)) && (unit_y[2] == y)) || ((unit_x[2] == x) && (unit_y[2] == (y + 1))) || ((unit_x[2] == x) && (unit_y[2] == (y -1))))
		{
			if ((world[unit_y[2]][unit_x[2]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Sabrainfo,Minion4,bonus);
			Sabrainfo.current_HP = Sabrainfo.current_HP - damagetemp;
		}
		// is baldur next to this unit?  if yes then attack him, else look for someone else,
		else if (((unit_x[3] == (x + 1)) && (unit_y[3] == y)) || ((unit_x[3] == (x - 1)) && (unit_y[3] == y)) || ((unit_x[3] == x) && (unit_y[3] == (y + 1))) || ((unit_x[3] == x) && (unit_y[3] == (y -1))))
		{
			if ((world[unit_y[3]][unit_x[2]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Baldurinfo,Minion4,bonus);
			Baldurinfo.current_HP = Baldurinfo.current_HP - damagetemp;
		}
		else // you can't attack, so defend
		{
			if(Minion4.defense_bonus < 15) // add 5 to the unit's defense if it's < 15
				Minion4.defense_bonus = Minion4.defense_bonus + 5;
		}
	}
	// if the unit is NOT dead, and the game isn't over
	if((unit_x[9] != -1) && (!defeatflag))
	{
		Unit_Movement(unit_x[9],unit_y[9]); // find the valid moves
		move_x[move_index] = unit_x[9]; // add the square the unit is standing in to the move possible move list
		move_y[move_index] = unit_y[9];
		move_index++;

		AI_Move(x,y); // have the computer select it's move

		if((x != unit_x[5]) || (y != unit_y[5])) // if the unit has moved, destroy it's defense bonus
			Minion5.defense_bonus = 0;
		
		unit_x[9] = x; // move the unit's x
		unit_y[9] = y; // move the unit's y

		move_index = 0;

		// is garret next to this unit? if yes then attack him, else look for someone else, else defend
		if (((unit_x[1] == (x + 1)) && (unit_y[1] == y)) || ((unit_x[1] == (x - 1)) && (unit_y[1] == y)) || ((unit_x[1] == x) && (unit_y[1] == (y + 1))) || ((unit_x[1] == x) && (unit_y[1] == (y -1))))
		{ 
			// find the terrain bonus for the terrain the unit's on
			if ((world[unit_y[1]][unit_x[1]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[1]][unit_x[1]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Garretinfo,Minion5,bonus);
			Garretinfo.current_HP = Garretinfo.current_HP - damagetemp;
		}
		// is sabra next to this unit?  if yes then attack her, else look for someone else,
		else if (((unit_x[2] == (x + 1)) && (unit_y[2] == y)) || ((unit_x[2] == (x - 1)) && (unit_y[2] == y)) || ((unit_x[2] == x) && (unit_y[2] == (y + 1))) || ((unit_x[2] == x) && (unit_y[2] == (y -1))))
		{
			if ((world[unit_y[2]][unit_x[2]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[2]][unit_x[2]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Sabrainfo,Minion5,bonus);
			Sabrainfo.current_HP = Sabrainfo.current_HP - damagetemp;
		}
		// is baldur next to this unit?  if yes then attack him, else look for someone else,
		else if (((unit_x[3] == (x + 1)) && (unit_y[3] == y)) || ((unit_x[3] == (x - 1)) && (unit_y[3] == y)) || ((unit_x[3] == x) && (unit_y[3] == (y + 1))) || ((unit_x[3] == x) && (unit_y[3] == (y -1))))
		{
			if ((world[unit_y[3]][unit_x[3]] - '0') == 2)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 3)
				bonus = -10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 4)
				bonus = 0;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 5)
				bonus = 10;
			else if ((world[unit_y[3]][unit_x[3]] - '0') == 7)
				bonus = 20;

			//have the unit attack, and then subtract hit points from the unit that was attacked
			damagetemp = Attackfunction(Baldurinfo,Minion5,bonus);
			Baldurinfo.current_HP = Baldurinfo.current_HP - damagetemp;
		}
		else // you can't attack, so defend
		{
			if(Minion5.defense_bonus < 15) // add 5 to the unit's defense if it's < 15
				Minion5.defense_bonus = Minion5.defense_bonus + 5;
		}
	}

	// check each player unit, if it's dead then remove it...
	if (Garretinfo.current_HP <= 0)
	{
		unit_x[1] = -1;
		unit_y[1] = -1;
	}
	
	if (Sabrainfo.current_HP <= 0)
	{
		unit_x[2] = -1;
		unit_y[2] = -1;
	}
	
	if (Baldurinfo.current_HP <= 0)
	{
		unit_x[3] = -1;
		unit_y[3] = -1;
	}

	//check for victory or defeat
	if((Garretinfo.current_HP <= 0) && (Sabrainfo.current_HP <= 0) && (Baldurinfo.current_HP <= 0))
	{	
		DMusic_Stop(music);
		defeatflag = true;
	}
	else if ((Boss.current_HP <= 0) && (Minion1.current_HP <= 0) && (Minion2.current_HP <= 0) && (Minion3.current_HP <= 0) && (Minion4.current_HP <= 0) && (Minion5.current_HP <= 0))
	{
		DMusic_Stop(music);
		victoryflag = true;
	}

	//reset the move and turn flags so the player can move
	Garretinfo.move_done= false;
	Sabrainfo.move_done = false;
	Baldurinfo.move_done = false;

	Garretinfo.turn_done = false;
	Sabrainfo.turn_done = false;
	Baldurinfo.turn_done = false;

	// increment the turn
	if(!defeatflag)
		turn++;
}

// if the enter key has been hit
if (KEY_DOWN(VK_RETURN))
{
	// This while prevents Enter from being hit repeatedly in a row.
	// Without it the Enter key is too sensetive.
	while(!(KEY_UP(VK_RETURN)))
	{
	};
	
	// look through the unit location arrays
	while(index2 < 4)
	{
		// if the curser is over a player unit
		if((unit_x[index2] == curserindex_x) && (unit_y[index2] == curserindex_y))
			if (index2 == 1) // if that unit is Garret
			{
				if (!Garretinfo.turn_done) // if garret can move
					moveflag = true; 
			}
			else if (index2 == 2) // if that unit is Sabra
			{
				if (!Sabrainfo.turn_done) // if sabra can move
					moveflag = true;
			}
			else if (index2 == 3) // if that unit is Baldur
			{
				if (!Baldurinfo.turn_done) // if baldur can move
					moveflag = true;
			}
		index2++;
	}
	index2 = 0;

	// this code moves the unit to the selected spot
	if (canmoveflag) //Move the unit
	{
		while(index < move_index) // move trough the move arrays
		{
			// if the move is valid
			if((move_x[index] == curserindex_x) && (move_y[index] == curserindex_y))
			{
				//move the unit
				unit_x[unit_move] = curserindex_x;
				unit_y[unit_move] = curserindex_y;

				// reset the defense bonus, mark the unit as moved
				if (unit_move == 1)
				{
					Garretinfo.defense_bonus = 0;
					Garretinfo.move_done = true;
				}
				// reset the defense bonus, mark the unit as moved
				else if (unit_move == 2)
				{
					Sabrainfo.defense_bonus = 0;
					Sabrainfo.move_done = true;
				}
				// reset the defense bonus, mark the unit as moved
				else if (unit_move == 3)
				{
					Baldurinfo.defense_bonus = 0;
					Baldurinfo.move_done = true;
				}
						
				move_index = 0;  // reset the move index
				canmoveflag = false; // reset the flag
				orderposition = -1; // reset the order marker
			}
			index++;
		}
		index = 0;

		DSound_Play(move_sound);  // play the move sound
	}
	else if (attackflag) //if the unit is attacking
	{
		// is the curser on a square that is next to the attacking unit?
		if (((curserindex_x == temp_cx + 1) && (curserindex_y == temp_cy)) || ((curserindex_x == temp_cx - 1) && (curserindex_y == temp_cy)) || ((curserindex_x == temp_cx) && (curserindex_y == temp_cy + 1)) || ((curserindex_x == temp_cx) && (curserindex_y == temp_cy - 1)))
		{
			// does the square that the unit is attacking contain a unit?
			while(index < 10)
			{
				// does the square that the unit is attacking contain a unit?
				if ((unit_x[index] == curserindex_x) && (unit_y[index] == curserindex_y))
				{
					// find the terrain bonus for the terrain the attacking unit is on
					if((world[curserindex_y][curserindex_x] - '0') == 2)
						bonus = 0;
					else if((world[curserindex_y][curserindex_x] - '0') == 3)
						bonus = 0;
					else if((world[curserindex_y][curserindex_x] - '0') == 4)
						bonus = -10;
					else if((world[curserindex_y][curserindex_x] - '0') == 5)
						bonus = 10;
					else if((world[curserindex_y][curserindex_x] - '0') == 7)
						bonus = 20;

					// figure out which unit is attacking
					if (unit_temp == 1)  // Garret
					{
						game_unit_temp = Garretinfo;
						Garretinfo.turn_done = true;
					}
					else if (unit_temp == 2)  // Sabra
					{
						game_unit_temp = Sabrainfo;
						Sabrainfo.turn_done = true;
					}
					else if (unit_temp == 3)  //Baldur
					{
						game_unit_temp = Baldurinfo;
						Baldurinfo.turn_done = true;
					}
			
					// find out which unit is defending, calculate the damage, then apply it to the unit
					if (index == 1) // garret
						Garretinfo.current_HP = Garretinfo.current_HP - Attackfunction(Garretinfo,game_unit_temp,bonus);
					else if (index == 2) //sabra
						Sabrainfo.current_HP = Sabrainfo.current_HP - Attackfunction(Sabrainfo,game_unit_temp,bonus);
					else if (index == 3) //baldur
						Baldurinfo.current_HP = Baldurinfo.current_HP - Attackfunction(Baldurinfo,game_unit_temp,bonus);
					else if (index == 4) //boss
						Boss.current_HP = Boss.current_HP - Attackfunction(Boss,game_unit_temp,bonus);
					else if (index == 5) //minion1
						Minion1.current_HP = Minion1.current_HP - Attackfunction(Minion1,game_unit_temp,bonus);
					else if (index == 6) //minion2
						Minion2.current_HP = Minion2.current_HP - Attackfunction(Minion2,game_unit_temp,bonus);
					else if (index == 7) //minion3
						Minion3.current_HP = Minion3.current_HP - Attackfunction(Minion3,game_unit_temp,bonus);
					else if (index == 8) //minion4
						Minion4.current_HP = Minion4.current_HP - Attackfunction(Minion4,game_unit_temp,bonus);
					else if (index == 9) //minion5
						Minion5.current_HP = Minion5.current_HP - Attackfunction(Minion5,game_unit_temp,bonus);

					//look at each unit, if they're dead, kill them
					if (Garretinfo.current_HP <= 0)
					{
						unit_x[1] = -1;
						unit_y[1] = -1;
					}
					
					if (Sabrainfo.current_HP <= 0)
					{
						unit_x[2] = -1;
						unit_y[2] = -1;
					}
					
					if (Baldurinfo.current_HP <= 0)
					{
						unit_x[3] = -1;
						unit_y[3] = -1;
					}
					
					if (Boss.current_HP <= 0)
					{
						unit_x[4] = -1;
						unit_y[4] = -1;
					}
					
					if (Minion1.current_HP <= 0)
					{
						unit_x[5] = -1;
						unit_y[5] = -1;
					}
					
					if (Minion2.current_HP <= 0)
					{
						unit_x[6] = -1;
						unit_y[6] = -1;
					}
					
					if (Minion3.current_HP <= 0)
					{
						unit_x[7] = -1;
						unit_y[7] = -1;
					}
					
					if (Minion4.current_HP <= 0)
					{
						unit_x[8] = -1;
						unit_y[8] = -1;
					}
					
					if (Minion5.current_HP <= 0)
					{
						unit_x[9] = -1;
						unit_y[9] = -1;
					}

				}
				index++;
			}
			index = 0;

			DSound_Play(battle_sound); // play the attack sound
		}

		//check for victory or defeat
		if((Garretinfo.current_HP <= 0) && (Sabrainfo.current_HP <= 0) && (Baldurinfo.current_HP <= 9))
			defeatflag = true;
		else if ((Boss.current_HP <= 0) && (Minion1.current_HP <= 0) && (Minion2.current_HP <= 0) && (Minion3.current_HP <= 0) && (Minion4.current_HP <= 0) && (Minion5.current_HP <= 0))
			victoryflag = true;

		orderposition = -1;
		attackflag = false;
	}
	else if (!curserflag)  //if the curser is on a friendly unit
	{
		if (orderposition == 0) //MOVE ORDER CODE HERE
		{
			// move through the unit arrays to find which unit is moving
			while(index2 < 4)
			{
				if((unit_x[index2] == curserindex_x) && (unit_y[index2] == curserindex_y))
					if (index2 == 1) // garret it moving
					{
						if (!Garretinfo.move_done)
						{
							// find all the valid moves
							Unit_Movement(curserindex_x,curserindex_y);
							move_x[move_index] = unit_x[1]; // add the square the unit's standing on
							move_y[move_index] = unit_y[1];
							move_index++;

							canmoveflag = true; // set various flags
							curserflag = true;
						}
					}
					else if (index2 == 2) // sabra is moving
					{
						if (!Sabrainfo.move_done)
						{
							// find all the valid moves
							Unit_Movement(curserindex_x,curserindex_y);
							move_x[move_index] = unit_x[2]; // add the square the unit's standing on
							move_y[move_index] = unit_y[2];
							move_index++;

							canmoveflag = true; // set various flags
							curserflag = true;
						}
					}
					else if (index2 == 3) // baldur is moving
					{
						if (!Baldurinfo.move_done)
						{
							// find all the valid moves
							Unit_Movement(curserindex_x,curserindex_y);
							move_x[move_index] = unit_x[3]; // add the square the unit's standing on
							move_y[move_index] = unit_y[3];
							move_index++;

							canmoveflag = true; // set various flags
							curserflag = true;
						}
					}
				index2++;
			}
			index2 = 0;
	
			orderposition = -1;
			curserflag = true;
		}
		else if (orderposition == 1) //ATTACK ORDER CODE HERE
		{	
			// find the attacking unit
			while(index < 10)
			{
				if ((unit_x[index] == curserindex_x) && (unit_y[index] == curserindex_y))
				{
					unit_temp = index;
				}
				index++;
			}
			index = 0;

			//remember which square the unit is on
			temp_cx = curserindex_x;
			temp_cy = curserindex_y;

			attackflag = true; //set various flags
			curserflag = true;
		}
		else if (orderposition == 2) //DEFENSE ORDER CODE HERE
		{
			// find the defend unit
			while (index < 10)
			{
				if((unit_x[index] == curserindex_x) && (unit_y[index] == curserindex_y))
					unit_temp = index;
					
				index++;
			}
			index = 0;

			if (unit_temp == 1) // if garret
			{
				if(Garretinfo.defense_bonus < 15) // add 5 to the unit's defense if it's < 15
					Garretinfo.defense_bonus = Garretinfo.defense_bonus + 5;

				Garretinfo.turn_done = true;
			}
			else if (unit_temp == 2) // if sabra
			{
				if(Sabrainfo.defense_bonus < 15) // add 5 to the unit's defense if it's < 15
					Sabrainfo.defense_bonus = Sabrainfo.defense_bonus + 5;

				Sabrainfo.turn_done = true;
			}
			else if (unit_temp == 3) // if baldur
			{
				if(Baldurinfo.defense_bonus < 15) // add 5 to the unit's defense if it's < 15
					Baldurinfo.defense_bonus = Baldurinfo.defense_bonus + 5;

				Baldurinfo.turn_done = true;
			}

			DSound_Play(defend_sound); // play the defend sound

			orderposition = -1;
			curserflag = true;
		}
		else if (orderposition == 3) // if the player selects quit, quit the game
		{
			PostMessage(main_window_handle, WM_DESTROY,0,0);
		}
	}
	// turn the curser "off" and let the player pick an order
	else if (moveflag)
	{
		curserflag = false;
		orderposition = 0;
	}
	moveflag = false;
}

// check for movement (scrolling)
if (KEY_DOWN(VK_RIGHT))
    {
		while(!(KEY_UP(VK_RIGHT))) //sensetive keys
		{
		};

		// this code moves the curser and/or the map
		if (curserflag) // if the player can move the curser
		{
			if (curser_x < 704)
				curser_x = curser_x + 64;
			else
				world_x = world_x +64;

			if (world_x >= 1152)
			{
				world_x = 1152;
			
				if (curser_x >= 640)
					curser_x = 640;
			}

			if (curserindex_x < 28)
				curserindex_x = curserindex_x + 1;
		}

    } // end if
else
if (KEY_DOWN(VK_LEFT))
    {
		while(!(KEY_UP(VK_LEFT))) //sensetive keys
		{
		};

		// this code moves the curser and/or the map
		if (curserflag) // if the player can move the curser
		{
			if (curser_x >= 64)
				curser_x = curser_x - 64;

			if ((world_x >= 0) && (curser_x <= 0))
			{
				world_x = world_x - 64;
				curser_x = curser_x + 64;
			}

			if (curser_x <= 64)
				curser_x = 64;

			if(world_x <= 0)
				world_x = 0;

			if (curserindex_x > 1)
				curserindex_x = curserindex_x - 1;
		}

    } // end if

if (KEY_DOWN(VK_UP))
    {
		while(!(KEY_UP(VK_UP))) //sensetive keys
		{
		};

		// this code moves the curser and/or the map
		if (curserflag) // if the player can move the curser
		{
			if (curser_y >= 64)
				curser_y = curser_y - 64;

			if ((world_y >= 0) && (curser_y <= 0))
			{
				world_y = world_y - 64;
				curser_y = curser_y + 64;
			}

			if (curser_y <= 64)
				curser_y = 64;

			if(world_y <= 0)
				world_y = 0;

			if (curserindex_y > 1)
				curserindex_y = curserindex_y - 1;
		}
		else // else the player moves the order menu
		{
			if (orderposition > 0)
				orderposition--;
		}

    } // end if
else
if (KEY_DOWN(VK_DOWN)) //sensetive keys
    {
		while(!(KEY_UP(VK_DOWN)))
		{
		};

		// this code moves the curser and/or the map
		if (curserflag) // if the player can move the curser
		{
			if (curser_y < 320)
				curser_y = curser_y + 64;
			else
				world_y = world_y +64;

			if (world_y >= 896)
			{
				world_y = 896;
			
				if (curser_y >= 320)
					curser_y = 320;
			}

			if (curserindex_y < 19)
				curserindex_y = curserindex_y + 1;
		}
		else // else the player moves the order menu
		{
			if (orderposition < 3)
				orderposition++;
		}

    } // end if

// compute starting map indices by dividing position by size of cell
start_map_x = world_x/64; // use >> 6 for speed, but this is clearer
start_map_y = world_y/64; 

// compute end of map rectangle for best cast i.e. aligned on 64x64 boundary
end_map_x = start_map_x + 13 - 1;
end_map_y = start_map_y + 7 - 1;

// now compute number of pixels in x,y we are within the tile, i.e
// how much is scrolled off the edge?
offset_x = -(world_x % 64);
offset_y = -(world_y % 64);

// adjust end_map_x,y for offsets
if (offset_x)
end_map_x++;

if (offset_y)
end_map_y++;


// set starting position of first upper lh texture
int texture_x = offset_x;
int texture_y = offset_y;

// draw the current window
for (index_y = start_map_y; index_y <= end_map_y; index_y++)
	{
	for (index_x = start_map_x; index_x <= end_map_x; index_x++)
		{
		// set position to blit
		textures.x = texture_x;
		textures.y = texture_y;
	        
		// set frame
		textures.curr_frame = world[index_y][index_x] - '0';

		// draw the texture
		Draw_BOB16(&textures,lpddsback);

		// Draw the "move" cursers in the correct squares
		while (index < move_index)
		{
			//This code moves through the move arrays and then displays
			//the valid moves on the screen
			if((move_x[index] == index_x) && (move_y[index] == index_y))
			{
				temp_x = curser.x;
				temp_y = curser.y;

				curser.curr_frame = 1;
				curser.x = texture_x;
				curser.y = texture_y;

				Draw_BOB16(&curser,lpddsback);

				curser.curr_frame = 0;
				curser.x = temp_x;
				curser.y = temp_y;
			}

			index++;
		}
		index = 0;

		// Draw the units cursers on the screen
		while(index < 10)
		{
			//this code moves through the unit arrays and then displays
			//the units on the screen
			if((unit_x[index] == index_x) && (unit_y[index] == index_y))
			{
				if (index == 1)
				{
					if (Garretinfo.cclass == 1)
						object_ptr = &garret;
					else if (Garretinfo.cclass == 2)
						object_ptr = &garret_ranger;
					else if (Garretinfo.cclass == 3)
						object_ptr = &garret_horsemen;				
				}
				else if (index == 2)
				{
					if (Sabrainfo.cclass == 1)
						object_ptr = &sabra;
					else if (Sabrainfo.cclass == 2)
						object_ptr = &sabra_ranger;
					else if (Sabrainfo.cclass == 3)
						object_ptr = &sabra_horsemen;
				}
				else if (index == 3)
				{
					if (Baldurinfo.cclass == 1)
						object_ptr = &baldur;
					else if (Baldurinfo.cclass == 2)
						object_ptr = &baldur_ranger;
					else if (Baldurinfo.cclass == 3)
						object_ptr = &baldur_horsemen;
				}
				else if (index == 4)
					object_ptr = &enemyboss;
				else if (index >= 5)
					object_ptr = &enemyminion;
	
				//Draw the unit on the screen
				object_ptr->x = texture_x;
				object_ptr->y = texture_y;
				Draw_BOB16(object_ptr,lpddsback);
				Animate_BOB(object_ptr);
			}
			index++;
		}
		index = 0;

		// update texture position
		texture_x+=64;

		} // end for map_x

	// reset x postion, update y
	texture_x =  offset_x;
	texture_y += 64;

	} // end for map_y

//Draw the curser on the screen
curser.curr_frame = 0;
curser.x = curser_x;
curser.y = curser_y;

Draw_BOB16(&curser,lpddsback);

//This code looks impressive, but it's not.
//It figures out which unit, if any, is under the curser
//Then it displays infomation about that unit to the screen
if ((unit_x[1] == curserindex_x) && (unit_y[1] == curserindex_y))
{
	sprintf(buffer,"Garret");
	Draw_Text_GDI(buffer,25,screen_height - 32 - 115,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Levels:  Fighter:  %d", Garretinfo.fighter_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 100,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Hit Points:  [%d] / [%d]", Garretinfo.current_HP, Garretinfo.HP);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 75,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Attack:  [%d]", Garretinfo.attack);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 60,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Defense:  [%d]     +[%d] Defend bonus", Garretinfo.defense, Garretinfo.defense_bonus);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 45,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Movement:  [%d]", Garretinfo.movement);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 30,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Experence:  [%d] / [%d]", Garretinfo.XP, Garretinfo.next_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 15,RGB(255,255,255),lpddsback);
}
else if ((unit_x[2] == curserindex_x) && (unit_y[2] == curserindex_y))
{
	sprintf(buffer,"Sabra");
	Draw_Text_GDI(buffer,25,screen_height - 32 - 115,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Levels:  Fighter:  %d", Sabrainfo.fighter_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 100,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Hit Points:  [%d] / [%d]", Sabrainfo.current_HP, Sabrainfo.HP);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 75,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Attack:  [%d]", Sabrainfo.attack);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 60,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Defense:  [%d]     +[%d] Defend bonus", Sabrainfo.defense, Sabrainfo.defense_bonus);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 45,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Movement:  [%d]", Sabrainfo.movement);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 30,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Experence:  [%d] / [%d]", Sabrainfo.XP, Sabrainfo.next_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 15,RGB(255,255,255),lpddsback);
}
else if ((unit_x[3] == curserindex_x) && (unit_y[3] == curserindex_y))
{
	sprintf(buffer,"Baldur");
	Draw_Text_GDI(buffer,25,screen_height - 32 - 115,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Levels:  Fighter:  %d", Baldurinfo.fighter_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 100,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Hit Points:  [%d] / [%d]", Baldurinfo.current_HP, Baldurinfo.HP);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 75,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Attack:  [%d]", Baldurinfo.attack);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 60,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Defense:  [%d]     +[%d] Defend bonus", Baldurinfo.defense, Baldurinfo.defense_bonus);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 45,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Movement:  [%d]", Baldurinfo.movement);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 30,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Experence:  [%d] / [%d]", Baldurinfo.XP, Baldurinfo.next_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 15,RGB(255,255,255),lpddsback);
}
else if ((unit_x[4] == curserindex_x) && (unit_y[4] == curserindex_y))
{
	sprintf(buffer,"Morgen");
	Draw_Text_GDI(buffer,25,screen_height - 32 - 115,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Levels:  Fighter:  %d", Boss.fighter_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 100,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Hit Points:  [%d] / [%d]", Boss.current_HP, Boss.HP);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 75,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Attack:  [%d]", Boss.attack);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 60,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Defense:  [%d]     +[%d] Defend bonus", Boss.defense, Boss.defense_bonus);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 45,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Movement:  [%d]", Boss.movement);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 30,RGB(255,255,255),lpddsback);
}
else if ((unit_x[5] == curserindex_x) && (unit_y[5] == curserindex_y))
{
	sprintf(buffer,"Soldier");
	Draw_Text_GDI(buffer,25,screen_height - 32 - 115,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Levels:  Fighter:  %d", Minion1.fighter_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 100,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Hit Points:  [%d] / [%d]", Minion1.current_HP, Minion1.HP);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 75,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Attack:  [%d]", Minion1.attack);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 60,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Defense:  [%d]     +[%d] Defend bonus", Minion1.defense, Minion1.defense_bonus);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 45,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Movement:  [%d]", Minion1.movement);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 30,RGB(255,255,255),lpddsback);
}
else if ((unit_x[6] == curserindex_x) && (unit_y[6] == curserindex_y))
{
	sprintf(buffer,"Soldier");
	Draw_Text_GDI(buffer,25,screen_height - 32 - 115,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Levels:  Fighter:  %d", Minion2.fighter_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 100,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Hit Points:  [%d] / [%d]", Minion2.current_HP, Minion2.HP);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 75,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Attack:  [%d]", Minion2.attack);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 60,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Defense:  [%d]     +[%d] Defend bonus", Minion2.defense, Minion2.defense_bonus);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 45,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Movement:  [%d]", Minion2.movement);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 30,RGB(255,255,255),lpddsback);
}
else if ((unit_x[7] == curserindex_x) && (unit_y[7] == curserindex_y))
{
	sprintf(buffer,"Soldier");
	Draw_Text_GDI(buffer,25,screen_height - 32 - 115,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Levels:  Fighter:  %d", Minion3.fighter_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 100,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Hit Points:  [%d] / [%d]", Minion3.current_HP, Minion3.HP);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 75,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Attack:  [%d]", Minion3.attack);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 60,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Defense:  [%d]     +[%d] Defend bonus", Minion3.defense, Minion3.defense_bonus);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 45,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Movement:  [%d]", Minion3.movement);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 30,RGB(255,255,255),lpddsback);
}
else if ((unit_x[8] == curserindex_x) && (unit_y[8] == curserindex_y))
{
	sprintf(buffer,"Soldier");
	Draw_Text_GDI(buffer,25,screen_height - 32 - 115,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Levels:  Fighter:  %d", Minion4.fighter_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 100,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Hit Points:  [%d] / [%d]", Minion4.current_HP, Minion4.HP);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 75,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Attack:  [%d]", Minion4.attack);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 60,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Defense:  [%d]     +[%d] Defend bonus", Minion4.defense, Minion4.defense_bonus);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 45,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Movement:  [%d]", Minion4.movement);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 30,RGB(255,255,255),lpddsback);
}
else if ((unit_x[9] == curserindex_x) && (unit_y[9] == curserindex_y))
{
	sprintf(buffer,"Soldier");
	Draw_Text_GDI(buffer,25,screen_height - 32 - 115,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Levels:  Fighter:  %d", Minion5.fighter_level);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 100,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Hit Points:  [%d] / [%d]", Minion5.current_HP, Minion5.HP);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 75,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Attack:  [%d]", Minion5.attack);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 60,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Defense:  [%d]     +[%d] Defend bonus", Minion5.defense, Minion5.defense_bonus);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 45,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Movement:  [%d]", Minion5.movement);
	Draw_Text_GDI(buffer,25,screen_height - 32 - 30,RGB(255,255,255),lpddsback);
}

//Once again, this code looks impressive, but it's not.
//It figures out which terrain, is under the curser
//Then it displays infomation about that terrain to the screen
if((world[curserindex_y][curserindex_x] - '0') == 2)
{
	textures.x = 450;
	textures.y = screen_height - 32 - 90;
	        
	textures.curr_frame = 2;

	Draw_BOB16(&textures,lpddsback);
	
	sprintf(buffer,"Grassland");
	Draw_Text_GDI(buffer,450,screen_height - 32 - 105,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Normal Movement");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 90,RGB(255,255,255),lpddsback);

	sprintf(buffer,"+0 Defense Bonus");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 50,RGB(255,255,255),lpddsback);
}
else if((world[curserindex_y][curserindex_x] - '0') == 3)
{
	textures.x = 450;
	textures.y = screen_height - 32 - 90;
	        
	textures.curr_frame = 3;

	Draw_BOB16(&textures,lpddsback);
		
	sprintf(buffer,"Water");
	Draw_Text_GDI(buffer,450,screen_height - 32 - 105,RGB(255,255,255),lpddsback);

	sprintf(buffer,"High Movement Penalty");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 90,RGB(255,255,255),lpddsback);

	sprintf(buffer,"-10 Defense Bonus");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 50,RGB(255,255,255),lpddsback);
}
else if((world[curserindex_y][curserindex_x] - '0') == 4)
{
	textures.x = 450;
	textures.y = screen_height - 32 - 90;
        
	textures.curr_frame = 4;

	Draw_BOB16(&textures,lpddsback);
	
	sprintf(buffer,"Plains");
	Draw_Text_GDI(buffer,450,screen_height - 32 - 105,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Normal Movement");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 90,RGB(255,255,255),lpddsback);

	sprintf(buffer,"+0 Defense Bonus");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 50,RGB(255,255,255),lpddsback);
}
else if((world[curserindex_y][curserindex_x] - '0') == 5)
{
	textures.x = 450;
	textures.y = screen_height - 32 - 90;
	        
	textures.curr_frame = 5;

	Draw_BOB16(&textures,lpddsback);
		
	sprintf(buffer,"Forrest");
	Draw_Text_GDI(buffer,450,screen_height - 32 - 105,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Modarate Movement Penalty");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 90,RGB(255,255,255),lpddsback);

	sprintf(buffer,"+10 Defense Bonus");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 50,RGB(255,255,255),lpddsback);
}
else if((world[curserindex_y][curserindex_x] - '0') == 6)
{
	textures.x = 450;
	textures.y = screen_height - 32 - 90;
	        
	textures.curr_frame = 6;

	Draw_BOB16(&textures,lpddsback);
	
	sprintf(buffer,"Mountains");
	Draw_Text_GDI(buffer,450,screen_height - 32 - 105,RGB(255,255,255),lpddsback);

	sprintf(buffer,"Impassable");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 90,RGB(255,255,255),lpddsback);
}
else if((world[curserindex_y][curserindex_x] - '0') == 7)
{
	textures.x = 450;
	textures.y = screen_height - 32 - 90;
	        
	textures.curr_frame = 7;

	Draw_BOB16(&textures,lpddsback);
		
	sprintf(buffer,"Hills");
	Draw_Text_GDI(buffer,450,screen_height - 32 - 105,RGB(255,255,255),lpddsback);

	sprintf(buffer,"High Movement Penalty");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 90,RGB(255,255,255),lpddsback);

	sprintf(buffer,"+20 Defense Bonus");
	Draw_Text_GDI(buffer,525,screen_height - 32 - 50,RGB(255,255,255),lpddsback);
}

//This code draws the menu on the screen
if (orderposition == 0)
	Draw_Text_GDI("Move",375,460,RGB(255,0,0),lpddsback);
else
	Draw_Text_GDI("Move",375,460,RGB(255,255,255),lpddsback);

if (orderposition == 1)
	Draw_Text_GDI("Attack",375,485,RGB(255,0,0),lpddsback);
else
	Draw_Text_GDI("Attack",375,485,RGB(255,255,255),lpddsback);

if (orderposition == 2)
	Draw_Text_GDI("Defend",375,510,RGB(255,0,0),lpddsback);
else
	Draw_Text_GDI("Defend",375,510,RGB(255,255,255),lpddsback);

if (orderposition == 3)
	Draw_Text_GDI("Quit",375,560,RGB(255,0,0),lpddsback);
else
	Draw_Text_GDI("Quit",375,560,RGB(255,255,255),lpddsback);

sprintf(buffer,"Turn:  %d", turn);
Draw_Text_GDI(buffer,725,screen_height - 32 - 115,RGB(255,255,255),lpddsback);

//this code draws the victory/defeat boxes
	if(victoryflag)
	{
		victory.x = 200;
		victory.y = 200;
		Draw_BOB16(&victory,lpddsback);

		DSound_Play(victory_sound);
	}
	else if(defeatflag)
	{
		defeat.x = 200;
		defeat.y = 200;
		Draw_BOB16(&defeat,lpddsback);

		DSound_Play(defeat_sound);
	}


// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(30);

// return success
return(1);

} // end Game_Main

//////////////////////////////////////////////////////////

//This function sets up all the various paramaters for the game
void Setup()
{	
	turn = 1;

	for(int i=0;i<10;i++) // initialize the unit arrays to -1
	{
		unit_x[i] = -1;
		unit_y[i] = -1;
	}

	//This code sets the starting positions of all units
	unit_x[1] = 2;
	unit_y[1] = 2;

	unit_x[2] = 3;
	unit_y[2] = 1;

	unit_x[3] = 1;
	unit_y[3] = 3;

	unit_x[4] = 28;
	unit_y[4] = 19;

	unit_x[5] = 22;
	unit_y[5] = 9;
	
	unit_x[6] = 18;
	unit_y[6] = 15;

	unit_x[7] = 5;
	unit_y[7] = 7;

	unit_x[8] = 18;
	unit_y[8] = 2;

	unit_x[9] = 11;
	unit_y[9] = 19;
	
	//This code sets all the various parameters for each of the units
	sprintf(Garretinfo.name,"Garret");
	Garretinfo.cclass = 1;
	Garretinfo.attack = 10;
	Garretinfo.defense = 10;
	Garretinfo.movement = 4;
	Garretinfo.HP = 100;
	Garretinfo.current_HP = 100;
	Garretinfo.fighter_level = 1;
	Garretinfo.ranger_level = 0;
	Garretinfo.horsemen_level = 0;
	Garretinfo.XP = 0;
	Garretinfo.next_level = 100;
	Garretinfo.defense_bonus = 0;
	Garretinfo.turn_done = false;
	Garretinfo.move_done = false;

	sprintf(Sabrainfo.name,"Sabra");
	Sabrainfo.cclass = 1;
	Sabrainfo.attack = 10;
	Sabrainfo.defense = 10;
	Sabrainfo.movement = 4;
	Sabrainfo.HP = 100;
	Sabrainfo.current_HP = 100;
	Sabrainfo.fighter_level = 1;
	Sabrainfo.ranger_level = 0;
	Sabrainfo.horsemen_level = 0;
	Sabrainfo.XP = 0;
	Sabrainfo.next_level = 100;
	Sabrainfo.defense_bonus = 0;
	Sabrainfo.turn_done = false;
	Sabrainfo.move_done = false;

	sprintf(Baldurinfo.name,"Baldur");
	Baldurinfo.cclass = 1;
	Baldurinfo.attack = 10;
	Baldurinfo.defense = 10;
	Baldurinfo.movement = 4;
	Baldurinfo.HP = 100;
	Baldurinfo.current_HP = 100;
	Baldurinfo.fighter_level = 1;
	Baldurinfo.ranger_level = 0;
	Baldurinfo.horsemen_level = 0;
	Baldurinfo.XP = 0;
	Baldurinfo.next_level = 100;
	Baldurinfo.defense_bonus = 0;
	Baldurinfo.turn_done = false;
	Baldurinfo.move_done = false;

	sprintf(Boss.name,"Morgen");
	Boss.cclass = 1;
	Boss.attack = 21;
	Boss.defense = 19;
	Boss.movement = 5;
	Boss.HP = 200;
	Boss.current_HP = 200;
	Boss.fighter_level = 5;
	Boss.ranger_level = 0;
	Boss.horsemen_level = 0;
	Boss.XP = 0;
	Boss.next_level = 100;
	Boss.defense_bonus = 0;
	Boss.turn_done = false;
	Boss.move_done = false;

	sprintf(Minion1.name,"Soldier");
	Minion1.cclass = 1;
	Minion1.attack = 14;
	Minion1.defense = 15;
	Minion1.movement = 5;
	Minion1.HP = 150;
	Minion1.current_HP = 150;
	Minion1.fighter_level = 3;
	Minion1.ranger_level = 0;
	Minion1.horsemen_level = 0;
	Minion1.XP = 0;
	Minion1.next_level = 100;
	Minion1.defense_bonus = 0;
	Minion1.turn_done = false;
	Minion1.move_done = false;

	sprintf(Minion2.name,"Soldier");
	Minion2.cclass = 1;
	Minion2.attack = 18;
	Minion2.defense = 12;
	Minion2.movement = 5;
	Minion2.HP = 150;
	Minion2.current_HP = 150;
	Minion2.fighter_level = 3;
	Minion2.ranger_level = 0;
	Minion2.horsemen_level = 0;
	Minion2.XP = 0;
	Minion2.next_level = 100;
	Minion2.defense_bonus = 0;
	Minion2.turn_done = false;
	Minion2.move_done = false;

	sprintf(Minion3.name,"Soldier");
	Minion3.cclass = 1;
	Minion3.attack = 13;
	Minion3.defense = 12;
	Minion3.movement = 4;
	Minion3.HP = 125;
	Minion3.current_HP = 125;
	Minion3.fighter_level = 2;
	Minion3.ranger_level = 0;
	Minion3.horsemen_level = 0;
	Minion3.XP = 0;
	Minion3.next_level = 100;
	Minion3.defense_bonus = 0;
	Minion3.turn_done = false;
	Minion3.move_done = false;

	sprintf(Minion4.name,"Soldier");
	Minion4.cclass = 1;
	Minion4.attack = 10;
	Minion4.defense = 15;
	Minion4.movement = 4;
	Minion4.HP = 125;
	Minion4.current_HP = 125;
	Minion4.fighter_level = 2;
	Minion4.ranger_level = 0;
	Minion4.horsemen_level = 0;
	Minion4.XP = 0;
	Minion4.next_level = 100;
	Minion4.defense_bonus = 0;
	Minion4.turn_done = false;
	Minion4.move_done = false;

	sprintf(Minion5.name,"Soldier");
	Minion5.cclass = 1;
	Minion5.attack = 15;
	Minion5.defense = 10;
	Minion5.movement = 4;
	Minion5.HP = 125;
	Minion5.current_HP = 125;
	Minion5.fighter_level = 2;
	Minion5.ranger_level = 0;
	Minion5.horsemen_level = 0;
	Minion5.XP = 0;
	Minion5.next_level = 100;
	Minion5.defense_bonus = 0;
	Minion5.turn_done = false;
	Minion5.move_done = false;
}

//This function finds all the valid moves the unit can make
//then stores them in move_x, and move_y
void Unit_Movement(int x_index, int y_index)
{
	game_unit moveunit;
	int temp;

	while(temp < 10) //move through the unit array to figure out which unit to move
	{
		if ((unit_x[temp] == x_index) && (unit_y[temp] == y_index))
		{
			if (temp == 1) //move garret
			{
				unit_move = temp;  //remember the unit that you want to move!!!
				moveunit = Garretinfo;
			}
			else if (temp == 2) //move sabra
			{
				unit_move = temp;  //remember the unit that you want to move!!!
				moveunit = Sabrainfo;
			}
			else if (temp == 3) //move baldur
			{
				unit_move = temp;  //remember the unit that you want to move!!!
				moveunit = Baldurinfo;
			}
			else if (temp == 4) //move boss
			{
				unit_move = temp;  //remember the unit that you want to move!!!
				moveunit = Boss;
			}
			else if (temp == 5) //move minion1
			{
				unit_move = temp;  //remember the unit that you want to move!!!
				moveunit = Minion1;
			}
			else if (temp == 6) //move minion2
			{
				unit_move = temp;  //remember the unit that you want to move!!!
				moveunit = Minion2;
			}
			else if (temp == 7) //move minion3
			{
				unit_move = temp;  //remember the unit that you want to move!!!
				moveunit = Minion3;
			}
			else if (temp == 8) //move minion4
			{
				unit_move = temp;  //remember the unit that you want to move!!!
				moveunit = Minion4;
			}
			else if (temp == 9) //move minion5
			{
				unit_move = temp;  //remember the unit that you want to move!!!
				moveunit = Minion5;
			}
		}
		temp++;
	}
	temp = 0;
	
	//the move function is recursive, move left, right, down, then up
	Recusive_Move(moveunit.movement, x_index-1, y_index); //left
	Recusive_Move(moveunit.movement, x_index+1, y_index); //right
	Recusive_Move(moveunit.movement, x_index, y_index-1); //down
	Recusive_Move(moveunit.movement, x_index, y_index+1); //up
}

//This is the recursive move function
void Recusive_Move(int moveleft, int x_index, int y_index)
{
	int temp;
	int tempmove = world[y_index][x_index] - '0'; //find the terrain

	//if there is already a unit on that square, you can't move there, so return
	while (temp < 10)
	{
		if ((unit_x[temp] == x_index) && (unit_y[temp] == y_index))
			return;
		temp++;
	}
	temp = 0;

	if (tempmove == 0) //return if an invalid terrain
		return;
	else if (tempmove == 1) //return if an invalid terrain
		return;
	else if (tempmove == 2) //grass
	{
		moveleft = moveleft - 1; //decrease unit's movement
		if (moveleft < 0) //if the unit is out of movement return
			return;
		else //else this square is valid to move to
		{
			move_x[move_index] = x_index;
			move_y[move_index] = y_index;
			move_index++;
		}
	}
	else if (tempmove == 3) //water
	{
		moveleft = moveleft - 3; //decrease unit's movement
		if (moveleft < 0)//if the unit is out of movement return
			return;
		else //else this square is valid to move to
		{
			move_x[move_index] = x_index;
			move_y[move_index] = y_index;
			move_index++;
		}
	}
	else if (tempmove == 4) //plains
	{
		moveleft = moveleft - 1; //decrease unit's movement
		if (moveleft < 0)//if the unit is out of movement return
			return;
		else //else this square is valid to move to
		{
			move_x[move_index] = x_index;
			move_y[move_index] = y_index;
			move_index++;
		}
	}
	else if (tempmove == 5) //forrest
	{
		moveleft = moveleft - 2; //decrease unit's movement
		if (moveleft < 0)//if the unit is out of movement return
			return;
		else //else this square is valid to move to
		{
			move_x[move_index] = x_index;
			move_y[move_index] = y_index;
			move_index++;
		}
	}
	else if (tempmove == 6) //mountains invalid
		return;
	else if (tempmove == 7) //hills
	{
		moveleft = moveleft - 3; //decrease unit's movement
		if (moveleft < 0)//if the unit is out of movement return
			return;
		else //else this square is valid to move to
		{
			move_x[move_index] = x_index;
			move_y[move_index] = y_index;
			move_index++;
		}
	}

	//you've looked at this square, move on to the next
	Recusive_Move(moveleft, x_index-1, y_index); //left
	Recusive_Move(moveleft, x_index+1, y_index); //right
	Recusive_Move(moveleft, x_index, y_index-1); //down
	Recusive_Move(moveleft, x_index, y_index+1); //up
}

//This function calculates how much damage the unit causes
int Attackfunction(game_unit unit_defend,game_unit unit_attack,float bonus)
{
	srand((unsigned)time(NULL)); // seed random number generator

	float temp;
	int damage;
	int attack;
	int defense;

	temp = unit_defend.defense_bonus;

	attack = unit_attack.attack * 2 + (rand() % unit_attack.attack);
	defense = unit_defend.defense + (unit_defend.defense * (temp / 100)) + (unit_defend.defense * (bonus / 100));

	damage = attack - defense;

	//add experience to the unit if it's attacked or been attacked
	Add_XP(unit_defend, unit_attack, damage);

	return damage;
}

//This function evaluate all the possible moves that the computer can make
//it assigns each move a value, and picks the "best" move
void AI_Move(int &x, int &y)
{
	int terrain;
	int temp;
	int temp2;
	int i;

	//find the terrain of the square
	while(i < move_index)
	{
		if ((world[move_y[i]][move_x[i]] - '0') == 2)
			terrain = 0;
		else if ((world[move_y[i]][move_x[i]] - '0') == 3)
			terrain = -1;
		else if ((world[move_y[i]][move_x[i]] - '0') == 4)
			terrain = 0;
		else if ((world[move_y[i]][move_x[i]] - '0') == 5)
			terrain = 1;
		else if ((world[move_y[i]][move_x[i]] - '0') == 7)
			terrain = 2;

		//if garret's not dead
		if (unit_x[1] != -1)
		{
			//figure out how close this square is to garret, the closer the better
			//also take some other values into account, and give the square a score
			temp = (abs(unit_x[1] - move_x[i])) + (abs(unit_y[1] - move_y[i]));
			temp = 100 - temp;
			temp = temp + terrain;
			temp = temp * 100;
			temp = temp + (rand() % 10);

			// if this move is better then the last move, swap them
			if (temp2 < temp)
			{
				temp2 = temp;
				x = move_x[i];
				y = move_y[i];
			}
		}
		
		//if sabra's not dead
		if (unit_x[2] != -1)
		{
			//figure out how close this square is to sabra, the closer the better
			//also take some other values into account, and give the square a score
			temp = (abs(unit_x[2] - move_x[i])) + (abs(unit_y[2] - move_y[i]));
			temp = 100 - temp;
			temp = temp + terrain;
			temp = temp * 100;
			temp = temp + (rand() % 10);

			// if this move is better then the last move, swap them
			if (temp2 < temp)
			{
				temp2 = temp;
				x = move_x[i];
				y = move_y[i];
			}
		}
		
		//if baldur's not dead
		if (unit_x[3] != -1)
		{
			//figure out how close this square is to baldur, the closer the better
			//also take some other values into account, and give the square a score
			temp = (abs(unit_x[3] - move_x[i])) + (abs(unit_y[3] - move_y[i]));
			temp = 100 - temp;
			temp = temp + terrain;
			temp = temp * 100;
			temp = temp + (rand() % 10);

			// if this move is better then the last move, swap them
			if (temp2 < temp)
			{
				temp2 = temp;
				x = move_x[i];
				y = move_y[i];
			}
		}

		i++;
	}
	i = 0;
}

//This function calculates the experience each unit gets
//and raises their levels if nesessary
void Add_XP(game_unit unit_defend, game_unit unit_attack, int damage)
{
	int temp;
	int temp2;
	float temp3;

	while ((temp + temp2) != 5)
	{
		temp = rand() % 5;
		temp2 = rand() % 5;
	}

	//find the attacking or defending unit
	//calculate the xp
	//add the xp to the unit
	if (!strcmp(unit_attack.name,"Garret"))
	{
		Garretinfo.XP = Garretinfo.XP + Garretinfo.attack + damage;
	}
	else if (!strcmp(unit_attack.name,"Sabra"))
	{
		Sabrainfo.XP = Sabrainfo.XP + Sabrainfo.attack + damage;
	}
	else if (!strcmp(unit_attack.name,"Baldur"))
	{
		Baldurinfo.XP = Baldurinfo.XP + Baldurinfo.attack + damage;
	}
	else if (!strcmp(unit_defend.name,"Garret"))
	{
		Garretinfo.XP = Garretinfo.XP + damage;
	}
	else if (!strcmp(unit_defend.name,"Sabra"))
	{
		Sabrainfo.XP = Sabrainfo.XP + damage;
	}
	else if (!strcmp(unit_defend.name,"Baldur"))
	{
		Baldurinfo.XP = Baldurinfo.XP + damage;
	}

	//check each character to see if they've gained a level
	//if so, increase their stats
	if (Garretinfo.XP >= Garretinfo.next_level)
	{
		Garretinfo.fighter_level = Garretinfo.fighter_level + 1;
		Garretinfo.attack = Garretinfo.attack + temp;
		Garretinfo.defense = Garretinfo.defense + temp2;
		Garretinfo.HP = Garretinfo.HP + 25;
		Garretinfo.current_HP = Garretinfo.HP;

		temp3 = Garretinfo.next_level;
		Garretinfo.next_level = Garretinfo.next_level + (temp3 * 1.5);

		if ((Garretinfo.fighter_level % 3) == 0)
		{
			Garretinfo.movement = Garretinfo.movement + 1;
		}
	}
	else if (Sabrainfo.XP >= Sabrainfo.next_level)
	{
		Sabrainfo.fighter_level = Sabrainfo.fighter_level + 1;
		Sabrainfo.attack = Sabrainfo.attack + temp;
		Sabrainfo.defense = Sabrainfo.defense + temp2;
		Sabrainfo.HP = Sabrainfo.HP + 25;
		Sabrainfo.current_HP = Sabrainfo.HP;

		temp3 = Sabrainfo.next_level;
		Sabrainfo.next_level = Sabrainfo.next_level + temp3 * 1.5;

		if ((Sabrainfo.fighter_level % 3) == 0)
		{
			Sabrainfo.movement = Sabrainfo.movement + 1;
		}
	}
	else if (Baldurinfo.XP >= Baldurinfo.next_level)
	{
		Baldurinfo.fighter_level = Baldurinfo.fighter_level + 1;
		Baldurinfo.attack = Baldurinfo.attack + temp;
		Baldurinfo.defense = Baldurinfo.defense + temp2;
		Baldurinfo.HP = Baldurinfo.HP + 25;
		Baldurinfo.current_HP = Baldurinfo.HP;

		temp3 = Sabrainfo.next_level;
		Baldurinfo.next_level = Baldurinfo.next_level + temp3 * 1.5;

		if ((Baldurinfo.fighter_level % 3) == 0)
		{
			Baldurinfo.movement = Baldurinfo.movement + 1;
		}
	}
}